Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp	(revision 138)
@@ -20,42 +20,52 @@
 #undef  FUNCTION
 #define FUNCTION "Load_store_unit::Parameters"
-  Parameters::Parameters (uint32_t            size_store_queue       ,
-			  uint32_t            size_load_queue        ,
-			  uint32_t            size_speculative_access_queue,
-			  uint32_t            nb_port_check          ,
-			  Tspeculative_load_t speculative_load       ,
-			  uint32_t            nb_bypass_memory       ,
-			  uint32_t            nb_cache_port          ,
-			  uint32_t            nb_inst_memory         ,
-			  uint32_t            nb_context             ,
-			  uint32_t            nb_front_end           ,
-			  uint32_t            nb_ooo_engine          ,
-			  uint32_t            nb_packet              ,
-			  uint32_t            size_general_data      ,
-			  uint32_t            size_special_data      ,
-			  uint32_t            nb_general_register    ,
-			  uint32_t            nb_special_register    ,
-                          uint32_t            nb_thread              ,
-                          bool              * num_thread_valid       , //[nb_thread]
+  Parameters::Parameters (uint32_t            size_store_queue                   ,
+			  uint32_t            size_load_queue                    ,
+			  uint32_t            size_speculative_access_queue      ,
+                          uint32_t            nb_store_queue_bank                ,
+                          uint32_t            nb_load_queue_bank                 ,
+                          uint32_t            nb_port_check                      ,
+                          Tspeculative_load_t speculative_load                   ,
+                          Tpredictor_t        speculative_commit_predictor_scheme,
+                          uint32_t          * lsu_pht_size_counter               ,//[1]
+                          uint32_t          * lsu_pht_nb_counter                 ,//[1]
+			  uint32_t            nb_bypass_memory                   ,
+			  uint32_t            nb_cache_port                      ,
+			  uint32_t            nb_inst_memory                     ,
+			  uint32_t            nb_context                         ,
+			  uint32_t            nb_front_end                       ,
+			  uint32_t            nb_ooo_engine                      ,
+			  uint32_t            nb_packet                          ,
+			  uint32_t            size_general_data                  ,
+			  uint32_t            size_special_data                  ,
+			  uint32_t            nb_general_register                ,
+			  uint32_t            nb_special_register                ,
+                          uint32_t            nb_thread                          ,
+                          bool              * num_thread_valid                   , //[nb_thread]
                           bool                is_toplevel)
   {
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
 
-    _size_store_queue                      = size_store_queue       ;
-    _size_load_queue                       = size_load_queue        ;
-    _size_speculative_access_queue         = size_speculative_access_queue;
-    _nb_port_check                         = nb_port_check          ;
-    _speculative_load                      = speculative_load       ;
-    _nb_bypass_memory                      = nb_bypass_memory       ;
-    _nb_cache_port                         = nb_cache_port          ;
-    _nb_inst_memory                        = nb_inst_memory         ;
-    _nb_context                            = nb_context             ;
-    _nb_front_end                          = nb_front_end           ;
-    _nb_ooo_engine                         = nb_ooo_engine          ;
-    _nb_packet                             = nb_packet              ;
-    _nb_general_register                   = nb_general_register    ;
-    _nb_special_register                   = nb_special_register    ;
-    _nb_thread                             = nb_thread              ;
-    _num_thread_valid                      = num_thread_valid       ;
+    _size_store_queue                      = size_store_queue                   ;
+    _size_load_queue                       = size_load_queue                    ;
+    _size_speculative_access_queue         = size_speculative_access_queue      ;
+    _nb_store_queue_bank                   = nb_store_queue_bank                ;
+    _nb_load_queue_bank                    = nb_load_queue_bank                 ;
+    _nb_port_check                         = nb_port_check                      ;
+    _speculative_load                      = speculative_load                   ;
+    _speculative_commit_predictor_scheme   = speculative_commit_predictor_scheme;
+    _lsu_pht_size_counter                  = lsu_pht_size_counter               ;
+    _lsu_pht_nb_counter                    = lsu_pht_nb_counter                 ;
+    _nb_bypass_memory                      = nb_bypass_memory                   ;
+    _nb_cache_port                         = nb_cache_port                      ;
+    _nb_inst_memory                        = nb_inst_memory                     ;
+    _nb_context                            = nb_context                         ;
+    _nb_front_end                          = nb_front_end                       ;
+    _nb_ooo_engine                         = nb_ooo_engine                      ;
+    _nb_packet                             = nb_packet                          ;
+    _nb_general_register                   = nb_general_register                ;
+    _nb_special_register                   = nb_special_register                ;
+    _nb_thread                             = nb_thread                          ;
+    _num_thread_valid                      = num_thread_valid                   ;
     
     _size_speculative_access_queue_ptr     = log2(size_speculative_access_queue);
@@ -99,52 +109,4 @@
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
   };
-  
-// #undef  FUNCTION
-// #define FUNCTION "Load_store_unit::Parameters (copy)"
-//   Parameters::Parameters (Parameters & param):
-//     _size_store_queue        (param._size_store_queue       ),
-//     _size_load_queue         (param._size_load_queue        ),
-//     _size_speculative_access_queue (param._size_speculative_access_queue),
-//     _nb_port_check           (param._nb_port_check          ),
-//     _speculative_load        (param._speculative_load       ),
-//     _nb_bypass_memory        (param._nb_bypass_memory       ),
-//     _nb_cache_port           (param._nb_cache_port          ),
-//     _nb_inst_memory          (param._nb_inst_memory         ),
-//     _nb_context              (param._nb_context             ),
-//     _nb_front_end            (param._nb_front_end           ),
-//     _nb_ooo_engine           (param._nb_ooo_engine          ),
-//     _nb_packet               (param._nb_packet              ),
-//     _size_general_data       (param._size_general_data      ),
-//     _size_special_data       (param._size_special_data      ),
-//     _nb_general_register     (param._nb_general_register    ),
-//     _nb_special_register     (param._nb_special_register    ),
-
-//     _size_address_store_queue              (param._size_address_store_queue             ),
-//     _size_address_load_queue               (param._size_address_load_queue              ),
-//     _size_address_speculative_access_queue (param._size_address_speculative_access_queue),
-
-//     _size_context_id         (param._size_context_id        ),
-//     _size_front_end_id       (param._size_front_end_id      ),
-//     _size_ooo_engine_id      (param._size_ooo_engine_id     ),
-//     _size_packet_id          (param._size_packet_id         ),
-//     _size_general_register   (param._size_general_register  ),
-//     _size_special_register   (param._size_special_register  ),
-//     _size_dcache_context_id  (param._size_dcache_context_id ),
-//     _size_dcache_packet_id   (param._size_dcache_packet_id  ),
-
-//     _have_port_context_id    (param._have_port_context_id   ),
-//     _have_port_front_end_id  (param._have_port_front_end_id ),
-//     _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
-//     _have_port_packet_id     (param._have_port_packet_id    ),
-//     _have_port_dcache_context_id(param._have_port_dcache_context_id),
-//     _have_port_load_queue_ptr(param._have_port_load_queue_ptr),
-
-//     _mask_address_lsb        (param._mask_address_lsb),
-//     _mask_address_msb        (param._mask_address_msb)
-//   {
-//     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
-//     test();
-//     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
-//   };
 
 #undef  FUNCTION
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters_msg_error.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters_msg_error.cpp	(revision 138)
@@ -6,4 +6,5 @@
  */
 
+#include "Behavioural/include/Test.h"
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Parameters.h"
 #include <sstream>
@@ -29,5 +30,5 @@
     switch (_speculative_load)
       {
-      case SPECULATIVE_LOAD_COMMIT :
+      case SPECULATIVE_LOAD_ACCESS :
 	{
 	  if (not (_nb_bypass_memory == 0))
@@ -37,6 +38,6 @@
 	}
       case NO_SPECULATIVE_LOAD     :
-      case SPECULATIVE_LOAD_ACCESS :
       // case SPECULATIVE_LOAD_BYPASS :
+      // case SPECULATIVE_LOAD_COMMIT :
       default                      :
 	{
@@ -55,4 +56,30 @@
       test.error(_("Bypass number must be less than load_queue's size.\n"));
 
+    if (not is_multiple(_nb_store_queue_bank,_nb_inst_memory))
+      test.error(_("Number of bank of store queue must be a multiple of number input instruction.\n"));
+
+    if (not is_multiple(_nb_load_queue_bank,_nb_inst_memory))
+      test.error(_("Number of bank of load queue must be a multiple of number input instruction.\n"));
+    
+    switch (_speculative_commit_predictor_scheme)
+      {
+      case PREDICTOR_NEVER_TAKE  :
+      case PREDICTOR_ALWAYS_TAKE :
+      case PREDICTOR_COUNTER     :
+        {
+          break;
+        }
+      case PREDICTOR_STATIC      :
+      case PREDICTOR_LAST_TAKE   :
+      case PREDICTOR_LOCAL       :
+      case PREDICTOR_GLOBAL      :
+      case PREDICTOR_META        :
+      case PREDICTOR_CUSTOM      :
+        {
+          test.error(toString(_("Predictor scheme \"%s\" is unsupported for load scheme.\n"),toString(_speculative_commit_predictor_scheme).c_str()));
+          break;
+        }
+      }
+    
     if (_nb_cache_port > 1)
       test.warning(_("nb_cache_port > 1 is unsupported (Coming Soon).\n")); 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h	(revision 138)
@@ -26,4 +26,5 @@
   {
     //-----[ fields ]------------------------------------------------------------
+  public : uint32_t    _nb_inst_read            ;
   public : uint32_t    _size_read_queue         ;
   public : uint32_t    _size_reservation_station;
@@ -63,5 +64,6 @@
 
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  (uint32_t size_read_queue         ,
+  public : Parameters  (uint32_t nb_inst_read            ,
+                        uint32_t size_read_queue         ,
 			uint32_t size_reservation_station,
 			uint32_t nb_context              ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp	(revision 138)
@@ -19,5 +19,6 @@
 #undef  FUNCTION
 #define FUNCTION "Read_unit::Parameters"
-  Parameters::Parameters (uint32_t size_read_queue         ,
+  Parameters::Parameters (uint32_t nb_inst_read            ,
+                          uint32_t size_read_queue         ,
                           uint32_t size_reservation_station,
                           uint32_t nb_context              ,
@@ -40,4 +41,5 @@
     log_printf(FUNC,Read_unit,FUNCTION,"Begin");
 
+    _nb_inst_read             = nb_inst_read            ;
     _size_read_queue          = size_read_queue         ;
     _size_reservation_station = size_reservation_station;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_msg_error.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_msg_error.cpp	(revision 138)
@@ -27,4 +27,7 @@
     Parameters_test test ("Read_unit");
 
+    if (_nb_inst_read != 1)
+      test.error(_("nb_inst_read must be equal at 1.\n"));
+
     log_printf(FUNC,Read_unit,FUNCTION,"End");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/include/Parameters.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/include/Parameters.h	(revision 138)
@@ -28,4 +28,5 @@
   {
     //-----[ fields ]------------------------------------------------------------
+  public : uint32_t              _nb_inst_write                ;
   public : uint32_t              _size_write_queue             ;
   public : uint32_t              _size_execute_queue           ;
@@ -61,5 +62,6 @@
 
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  (uint32_t              size_write_queue   ,
+  public : Parameters  (uint32_t              nb_inst_write      ,
+                        uint32_t              size_write_queue   ,
 			uint32_t              size_execute_queue ,
 			uint32_t              nb_context         ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters.cpp	(revision 138)
@@ -19,5 +19,6 @@
 #undef  FUNCTION
 #define FUNCTION "Write_unit::Parameters"
-  Parameters::Parameters (uint32_t              size_write_queue   ,
+  Parameters::Parameters (uint32_t              nb_inst_write      ,
+                          uint32_t              size_write_queue   ,
 			  uint32_t              size_execute_queue ,
 			  uint32_t              nb_context         ,
@@ -36,4 +37,5 @@
     log_printf(FUNC,Write_unit,FUNCTION,"Begin");
 
+    _nb_inst_write                = nb_inst_write      ;
     _size_write_queue             = size_write_queue   ;
     _size_execute_queue           = size_execute_queue ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters_msg_error.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters_msg_error.cpp	(revision 138)
@@ -27,5 +27,8 @@
 
     if (_size_write_queue == 0)
-      test.error("Write queue must have a less one entry.");
+      test.error(_("Write queue must have a less one entry.\n"));
+
+    if (_nb_inst_write != 1)
+      test.error(_("nb_inst_write must be equal at 1.\n"));
 
     log_printf(FUNC,Write_unit,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Parameters.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Parameters.h	(revision 138)
@@ -54,10 +54,16 @@
   public : uint32_t            * _size_load_queue                               ; //[nb_load_store_unit]
   public : uint32_t            * _size_speculative_access_queue                 ; //[nb_load_store_unit]
+  public : uint32_t            * _nb_store_queue_bank                           ; //[nb_load_store_unit]
+  public : uint32_t            * _nb_load_queue_bank                            ; //[nb_load_store_unit]
   public : uint32_t            * _nb_port_check                                 ; //[nb_load_store_unit]
   public : Tspeculative_load_t * _speculative_load                              ; //[nb_load_store_unit]
+  public : Tpredictor_t        * _speculative_commit_predictor_scheme           ; //[nb_load_store_unit]
+  public : uint32_t           ** _lsu_pht_size_counter                          ; //[nb_load_store_unit][1]
+  public : uint32_t           ** _lsu_pht_nb_counter                            ; //[nb_load_store_unit][1]
   public : uint32_t            * _nb_bypass_memory                              ; //[nb_load_store_unit]
   public : uint32_t            * _nb_cache_port                                 ; //[nb_load_store_unit]
   public : uint32_t            * _nb_inst_memory                                ; //[nb_load_store_unit]
     //  * read_unit                                                                   
+  public : uint32_t            * _nb_inst_read                                  ; //[nb_read_unit]
   public : uint32_t            * _size_read_queue                               ; //[nb_read_unit]
   public : uint32_t            * _size_reservation_station                      ; //[nb_read_unit]
@@ -70,4 +76,5 @@
   public : bool               ** _link_read_unit_with_thread                    ; //[nb_read_unit][nb_thread]
     //  * write_unit                                                                  
+  public : uint32_t            * _nb_inst_write                                 ; //[nb_write_unit]
   public : uint32_t            * _size_write_queue                              ; //[nb_write_unit]
   public : uint32_t            * _size_execute_queue                            ; //[nb_write_unit]
@@ -158,4 +165,5 @@
                         uint32_t              size_special_data                             ,
                         
+                        uint32_t            * nb_inst_read                                  ,//[nb_read_unit]
                         uint32_t            * size_read_queue                               ,//[nb_read_unit]
                         uint32_t            * size_reservation_station                      ,//[nb_read_unit]
@@ -169,10 +177,16 @@
                         uint32_t            * size_load_queue                               ,//[nb_load_store_unit]
                         uint32_t            * size_speculative_access_queue                 ,//[nb_load_store_unit]
+                        uint32_t            * nb_store_queue_bank                           ,//[nb_load_store_unit]
+                        uint32_t            * nb_load_queue_bank                            ,//[nb_load_store_unit]
                         uint32_t            * nb_port_check                                 ,//[nb_load_store_unit]
                         Tspeculative_load_t * speculative_load                              ,//[nb_load_store_unit]
+                        Tpredictor_t        * speculative_commit_predictor_scheme           ,//[nb_load_store_unit]
+                        uint32_t           ** lsu_pht_size_counter                          ,//[nb_load_store_unit][1]
+                        uint32_t           ** lsu_pht_nb_counter                            ,//[nb_load_store_unit][1]
                         uint32_t            * nb_bypass_memory                              ,//[nb_load_store_unit]
                         uint32_t            * nb_cache_port                                 ,//[nb_load_store_unit]
                         uint32_t            * nb_inst_memory                                ,//[nb_load_store_unit]
                         
+                        uint32_t            * nb_inst_write                                 ,//[nb_write_unit]
                         uint32_t            * size_write_queue                              ,//[nb_write_unit]
                         uint32_t            * size_execute_queue                            ,//[nb_write_unit]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 138)
@@ -31,4 +31,5 @@
 			  uint32_t              size_special_data                         ,
 			  
+			  uint32_t            * nb_inst_read                              ,//[nb_read_unit]
 			  uint32_t            * size_read_queue                           ,//[nb_read_unit]
 			  uint32_t            * size_reservation_station                  ,//[nb_read_unit]
@@ -42,10 +43,16 @@
 			  uint32_t            * size_load_queue                           ,//[nb_load_store_unit]
 			  uint32_t            * size_speculative_access_queue             ,//[nb_load_store_unit]
-			  uint32_t            * nb_port_check                             ,//[nb_load_store_unit]
-			  Tspeculative_load_t * speculative_load                          ,//[nb_load_store_unit]
+                          uint32_t            * nb_store_queue_bank                       ,//[nb_load_store_unit]
+                          uint32_t            * nb_load_queue_bank                        ,//[nb_load_store_unit]
+                          uint32_t            * nb_port_check                             ,//[nb_load_store_unit]
+                          Tspeculative_load_t * speculative_load                          ,//[nb_load_store_unit]
+                          Tpredictor_t        * speculative_commit_predictor_scheme       ,//[nb_load_store_unit]
+                          uint32_t           ** lsu_pht_size_counter                      ,//[nb_load_store_unit][1]
+                          uint32_t           ** lsu_pht_nb_counter                        ,//[nb_load_store_unit][1]
 			  uint32_t            * nb_bypass_memory                          ,//[nb_load_store_unit]
 			  uint32_t            * nb_cache_port                             ,//[nb_load_store_unit]
 			  uint32_t            * nb_inst_memory                            ,//[nb_load_store_unit]
 
+			  uint32_t            * nb_inst_write                             ,//[nb_write_unit]
 			  uint32_t            * size_write_queue                          ,//[nb_write_unit]
 			  uint32_t            * size_execute_queue                        ,//[nb_write_unit]
@@ -92,4 +99,5 @@
     _nb_packet                                  = nb_packet                            ;
                                                 
+    _nb_inst_read                               = nb_inst_read                         ;
     _size_read_queue                            = size_read_queue                      ;
     _size_reservation_station                   = size_reservation_station             ;
@@ -100,9 +108,15 @@
     _get_custom_information                     = get_custom_information               ;
                                                 
+    _nb_inst_write                              = nb_inst_write                        ;
     _size_store_queue                           = size_store_queue                     ;
     _size_load_queue                            = size_load_queue                      ;
     _size_speculative_access_queue              = size_speculative_access_queue        ;
+    _nb_store_queue_bank                        = nb_store_queue_bank                  ;
+    _nb_load_queue_bank                         = nb_load_queue_bank                   ;
     _nb_port_check                              = nb_port_check                        ;
     _speculative_load                           = speculative_load                     ;
+    _speculative_commit_predictor_scheme        = speculative_commit_predictor_scheme  ;
+    _lsu_pht_size_counter                       = lsu_pht_size_counter                 ;
+    _lsu_pht_nb_counter                         = lsu_pht_nb_counter                   ;
     _nb_bypass_memory                           = nb_bypass_memory                     ;
     _nb_cache_port                              = nb_cache_port                        ;
@@ -379,5 +393,6 @@
     for (uint32_t i=0; i<_nb_read_unit; i++)
       _param_read_unit [i] = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::Parameters 
-	(_size_read_queue               [i],
+	(_nb_inst_read                  [i],
+         _size_read_queue               [i],
 	 _size_reservation_station      [i],
 	 _nb_context                       ,
@@ -421,22 +436,28 @@
         else
 	  _param_load_store_unit [x] = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_execute_unit::execute_unit::load_store_unit::Parameters
-	    (_size_store_queue              [x],
-	     _size_load_queue               [x],
-	     _size_speculative_access_queue [x],
-	     _nb_port_check                 [x],
-	     _speculative_load              [x],
-	     _nb_bypass_memory              [x],
-	     _nb_cache_port                 [x],
-	     _nb_inst_memory                [x],
-	     _nb_context                       ,
-	     _nb_front_end                     ,
-	     _nb_ooo_engine                    ,
-	     _nb_packet                        ,
-	      size_general_data                ,
-	      size_special_data                ,
-	     _max_nb_special_register          ,
-	     _max_nb_general_register          ,
-             _nb_thread                        ,
-             _num_thread_valid                 );
+	    (_size_store_queue                    [x],
+	     _size_load_queue                     [x],
+	     _size_speculative_access_queue       [x],
+
+	     _nb_store_queue_bank                 [x],
+	     _nb_load_queue_bank                  [x],
+	     _nb_port_check                       [x],
+	     _speculative_load                    [x],
+	     _speculative_commit_predictor_scheme [x],
+	     _lsu_pht_size_counter                [x],
+	     _lsu_pht_nb_counter                  [x],
+	     _nb_bypass_memory                    [x],
+	     _nb_cache_port                       [x],
+	     _nb_inst_memory                      [x],
+	     _nb_context                             ,
+	     _nb_front_end                           ,
+	     _nb_ooo_engine                          ,
+	     _nb_packet                              ,
+	      size_general_data                      ,
+	      size_special_data                      ,
+	     _max_nb_special_register                ,
+	     _max_nb_general_register                ,
+             _nb_thread                              ,
+             _num_thread_valid                       );
       }
 
@@ -446,5 +467,6 @@
     for (uint32_t i=0; i<_nb_write_unit; i++)
       _param_write_unit [i] = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_write_unit::write_unit::Parameters
-	(_size_write_queue        [i],
+	(_nb_inst_write           [i],
+	 _size_write_queue        [i],
 	 _size_execute_queue      [i],
 	 _nb_context                 ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Decod_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Decod_unit.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Decod_unit.cpp	(revision 138)
@@ -72,5 +72,5 @@
 #endif
 
-#ifdef SYSTEMC
+#if defined(SYSTEMC) and (defined(STATISTICS) or defined(VHDL_TESTBENCH))
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
@@ -84,7 +84,7 @@
 	// List dependency information
 # endif    
-	
+      }
 #endif
-      }
+
     log_end(Decod_unit,FUNCTION);
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit.cpp	(revision 138)
@@ -70,5 +70,5 @@
 #endif
 
-#ifdef SYSTEMC
+#if defined(SYSTEMC) and (defined(STATISTICS) or defined(VHDL_TESTBENCH))
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
@@ -82,7 +82,6 @@
 	// List dependency information
 # endif    
-	
+      }
 #endif
-      }
     log_printf(FUNC,Ifetch_unit,FUNCTION,"End");
   };
